""Sample some observations which, when averaged, will produce the plots from the paper. Put these observations into a dictionary and write it to a file in `samples/`.""
from make_graphs import plot
import numpy as np
from strgen import StringGenerator as sg
from datetime import datetime
import warnings
import sys


def _make_graphs_vs_bits(n_trials,
                         str_runid,
                         n_recv,
                         d_lo_inr,
                         d_hi_inr,
                         v_bits,
                         v_kfactor,
                         d_k_bits,
                         n_det_lvl):

    print('Making points vs bits, 4 helpers, -20 dB INR, no base')
    dict_bits_ni_nb, sam = plot.vs_bits(n_recv=n_recv,
                                        d_kfactor=d_k_bits,
                                        d_inr=d_lo_inr,
                                        v_max_bits=v_bits,
                                        n_trials=n_trials,
                                        b_no_base=True,
                                        n_detail_lvl=n_det_lvl)
    with open('plot csv/bits_ni_nb_ub.csv', 'wb') as f: 
        np.savetxt(f, np.array([v_bits, dict_bits_ni_nb['ub']]).T, delimiter=',')
    with open('plot csv/bits_ni_nb_bc.csv', 'wb') as f: 
        np.savetxt(f, np.array([v_bits, dict_bits_ni_nb['bc']]).T, delimiter=',')
    with open('plot csv/bits_ni_nb_ga.csv', 'wb') as f: 
        np.savetxt(f, np.array([v_bits, dict_bits_ni_nb['ga']]).T, delimiter=',')
    with open('plot csv/bits_ni_nb_dc.csv', 'wb') as f: 
        np.savetxt(f, np.array([v_bits, dict_bits_ni_nb['dc']]).T, delimiter=',')
    with open('samples/bits_ni_nb_'+str_runid+'.npy', 'wb') as f: 
        np.save(f, sam)

    print('Making points vs bits, 4 helpers, -20 dB INR, with base')
    dict_bits_ni_b, sam = plot.vs_bits(n_recv=n_recv,
                                       d_kfactor=d_k_bits,
                                       d_inr=d_lo_inr,
                                       v_max_bits=v_bits,
                                       n_trials=n_trials,
                                       b_no_base=False,
                                       n_detail_lvl=n_det_lvl)
    with open('plot csv/bits_ni_b_ub.csv', 'wb') as f: 
        np.savetxt(f, np.array([v_bits, dict_bits_ni_b['ub']]).T, delimiter=',')
    with open('plot csv/bits_ni_b_bc.csv', 'wb') as f: 
        np.savetxt(f, np.array([v_bits, dict_bits_ni_b['bc']]).T, delimiter=',')
    with open('plot csv/bits_ni_b_ga.csv', 'wb') as f: 
        np.savetxt(f, np.array([v_bits, dict_bits_ni_b['ga']]).T, delimiter=',')
    with open('plot csv/bits_ni_b_dc.csv', 'wb') as f: 
        np.savetxt(f, np.array([v_bits, dict_bits_ni_b['dc']]).T, delimiter=',')
    with open('samples/bits_ni_b_'+str_runid+'.npy', 'wb') as f: 
        np.save(f, sam)

    print('Making points vs bits, 4 helpers, +20 dB INR, no base')
    dict_bits_i_nb, sam = plot.vs_bits(n_recv=n_recv,
                                       d_kfactor=d_k_bits,
                                       d_inr=d_hi_inr,
                                       v_max_bits=v_bits,
                                       n_trials=n_trials,
                                       b_no_base=True,
                                       n_detail_lvl=n_det_lvl)
    with open('plot csv/bits_i_nb_ub.csv', 'wb') as f: 
        np.savetxt(f, np.array([v_bits, dict_bits_i_nb['ub']]).T, delimiter=',')
    with open('plot csv/bits_i_nb_bc.csv', 'wb') as f: 
        np.savetxt(f, np.array([v_bits, dict_bits_i_nb['bc']]).T, delimiter=',')
    with open('plot csv/bits_i_nb_ga.csv', 'wb') as f: 
        np.savetxt(f, np.array([v_bits, dict_bits_i_nb['ga']]).T, delimiter=',')
    with open('plot csv/bits_i_nb_dc.csv', 'wb') as f: 
        np.savetxt(f, np.array([v_bits, dict_bits_i_nb['dc']]).T, delimiter=',')
    with open('samples/bits_i_nb_'+str_runid+'.npy', 'wb') as f: 
        np.save(f, sam)

    print('Making points vs bits, 4 helpers, +20 dB INR, with base')
    dict_bits_i_b, sam = plot.vs_bits(n_recv=n_recv,
                                      d_kfactor=d_k_bits,
                                      d_inr=d_hi_inr,
                                      v_max_bits=v_bits,
                                      n_trials=n_trials,
                                      b_no_base=False,
                                      n_detail_lvl=n_det_lvl)
    with open('plot csv/bits_i_b_ub.csv', 'wb') as f: 
        np.savetxt(f, np.array([v_bits, dict_bits_i_b['ub']]).T, delimiter=',')
    with open('plot csv/bits_i_b_bc.csv', 'wb') as f: 
        np.savetxt(f, np.array([v_bits, dict_bits_i_b['bc']]).T, delimiter=',')
    with open('plot csv/bits_i_b_ga.csv', 'wb') as f: 
        np.savetxt(f, np.array([v_bits, dict_bits_i_b['ga']]).T, delimiter=',')
    with open('plot csv/bits_i_b_dc.csv', 'wb') as f: 
        np.savetxt(f, np.array([v_bits, dict_bits_i_b['dc']]).T, delimiter=',')
    with open('samples/bits_i_b_'+str_runid+'.npy', 'wb') as f: 
        np.save(f, sam)


def _make_graphs_vs_k(n_trials,
                      str_runid,
                      n_recv,
                      d_lo_inr,
                      d_hi_inr,
                      v_bits,
                      v_kfactor,
                      d_bits_for_k,
                      n_det_lvl):
    print('Making points vs K-factor, 4 helpers, 5 bit LAN, -20 dB INR, no base')
    dict_k_ni_nb, sam = plot.vs_k(n_recv=n_recv,
                                  v_kfactor=v_kfactor,
                                  d_inr=d_lo_inr,
                                  d_max_bits=d_bits_for_k,
                                  n_trials=n_trials,
                                  b_no_base=True,
                                  n_detail_lvl=n_det_lvl)
    with open('plot csv/k_ni_nb_ub.csv', 'wb') as f: 
        np.savetxt(f, np.array([v_kfactor, dict_k_ni_nb['ub']]).T, delimiter=',')
    with open('plot csv/k_ni_nb_bc.csv', 'wb') as f: 
        np.savetxt(f, np.array([v_kfactor, dict_k_ni_nb['bc']]).T, delimiter=',')
    with open('plot csv/k_ni_nb_ga.csv', 'wb') as f: 
        np.savetxt(f, np.array([v_kfactor, dict_k_ni_nb['ga']]).T, delimiter=',')
    with open('plot csv/k_ni_nb_dc.csv', 'wb') as f: 
        np.savetxt(f, np.array([v_kfactor, dict_k_ni_nb['dc']]).T, delimiter=',')
    nda_bitdistns = np.append([v_kfactor], [dict_k_ni_nb[iii] for iii in range(n_recv - 1)], 0)
    with open('plot csv/k_ni_nb_dist.csv', 'wb') as f: 
        np.savetxt(f, nda_bitdistns.T, delimiter=',')
    with open('samples/k_ni_nb_'+str_runid+'.npy', 'wb') as f: 
        np.save(f, sam)

    print('Making points vs K-factor, 4 helpers, 5 bit LAN, -20 dB INR, with base')
    dict_k_ni_b, sam = plot.vs_k(n_recv=n_recv,
                                 v_kfactor=v_kfactor,
                                 d_inr=d_lo_inr,
                                 d_max_bits=d_bits_for_k,
                                 n_trials=n_trials,
                                 b_no_base=False,
                                 n_detail_lvl=n_det_lvl)
    with open('plot csv/k_ni_b_ub.csv', 'wb') as f: 
        np.savetxt(f, np.array([v_kfactor, dict_k_ni_b['ub']]).T, delimiter=',')
    with open('plot csv/k_ni_b_bc.csv', 'wb') as f: 
        np.savetxt(f, np.array([v_kfactor, dict_k_ni_b['bc']]).T, delimiter=',')
    with open('plot csv/k_ni_b_ga.csv', 'wb') as f: 
        np.savetxt(f, np.array([v_kfactor, dict_k_ni_b['ga']]).T, delimiter=',')
    with open('plot csv/k_ni_b_dc.csv', 'wb') as f: 
        np.savetxt(f, np.array([v_kfactor, dict_k_ni_b['dc']]).T, delimiter=',')
    nda_bitdistns = np.append([v_kfactor], [dict_k_ni_b[iii] for iii in range(n_recv - 1)], 0)
    with open('plot csv/k_ni_b_dist.csv', 'wb') as f: 
        np.savetxt(f, nda_bitdistns.T, delimiter=',')
    with open('samples/k_ni_b_' + str_runid + '.npy', 'wb') as f: 
        np.save(f, sam)

    print('Making points vs K-factor, 4 helpers, 5 bit LAN, +20 dB INR, no base')
    dict_k_i_nb, sam = plot.vs_k(n_recv=n_recv,
                                 v_kfactor=v_kfactor,
                                 d_inr=d_hi_inr,
                                 d_max_bits=d_bits_for_k,
                                 n_trials=n_trials,
                                 b_no_base=True,
                                 n_detail_lvl=n_det_lvl)
    with open('plot csv/k_i_nb_ub.csv', 'wb') as f: 
        np.savetxt(f, np.array([v_kfactor, dict_k_i_nb['ub']]).T, delimiter=',')
    with open('plot csv/k_i_nb_bc.csv', 'wb') as f: 
        np.savetxt(f, np.array([v_kfactor, dict_k_i_nb['bc']]).T, delimiter=',')
    with open('plot csv/k_i_nb_ga.csv', 'wb') as f: 
        np.savetxt(f, np.array([v_kfactor, dict_k_i_nb['ga']]).T, delimiter=',')
    with open('plot csv/k_i_nb_dc.csv', 'wb') as f: 
        np.savetxt(f, np.array([v_kfactor, dict_k_i_nb['dc']]).T, delimiter=',')
    nda_bitdistns = np.append([v_kfactor], [dict_k_i_nb[iii] for iii in range(n_recv - 1)], 0)
    with open('plot csv/k_i_nb_dist.csv', 'wb') as f: 
        np.savetxt(f, nda_bitdistns.T, delimiter=',')
    with open('samples/k_i_nb_' + str_runid + '.npy', 'wb') as f: 
        np.save(f, sam)

    print('Making points vs K-factor, 4 helpers, 5 bit LAN, +20 dB INR, with base')
    dict_k_i_b, sam = plot.vs_k(n_recv=n_recv,
                                v_kfactor=v_kfactor,
                                d_inr=d_hi_inr,
                                d_max_bits=d_bits_for_k,
                                n_trials=n_trials,
                                b_no_base=False,
                                n_detail_lvl=n_det_lvl)

    with open('plot csv/k_i_b_ub.csv', 'wb') as f:
        np.savetxt(f, np.array([v_kfactor, dict_k_i_b['ub']]).T, delimiter=',')
    with open('plot csv/k_i_b_bc.csv', 'wb') as f: 
        np.savetxt(f, np.array([v_kfactor, dict_k_i_b['bc']]).T, delimiter=',')
    with open('plot csv/k_i_b_ga.csv', 'wb') as f: 
        np.savetxt(f, np.array([v_kfactor, dict_k_i_b['ga']]).T, delimiter=',')
    with open('plot csv/k_i_b_dc.csv', 'wb') as f: 
        np.savetxt(f, np.array([v_kfactor, dict_k_i_b['dc']]).T, delimiter=',')
    nda_bitdistns = np.append([v_kfactor], [dict_k_i_b[iii] for iii in range(n_recv - 1)], 0)
    with open('plot csv/k_i_b_dist.csv', 'wb') as f: 
        np.savetxt(f, nda_bitdistns.T, delimiter=',')
    with open('samples/k_i_b_' + str_runid + '.npy', 'wb') as f: 
        np.save(f, sam)


if __name__ == "__main__":
    warnings.filterwarnings("ignore")
    startTime = datetime.now()

    n_trials = 1

    str_runid = sg('[\\u\\d]{6}').render()
    n_det_lvl = 1

    n_recv = 5
    d_lo_inr = -20
    d_hi_inr = 20
    v_bits = np.append(np.arange(0, 9.9, 0.3), [10, 15, 20, 25, 30, 35, 40])
    v_kfactor = [-40, -20, -10, 0, 10, 20, 40]

    print('VS BITS')
    d_k_bits = -100
    _make_graphs_vs_bits(n_trials,
                         str_runid,
                         n_recv,
                         d_lo_inr,
                         d_hi_inr,
                         v_bits,
                         v_kfactor,
                         d_k_bits,
                         n_det_lvl)
    print('VS K-FACTOR')
    d_bits_for_k = 5
    _make_graphs_vs_k(n_trials,
                      str_runid,
                      n_recv,
                      d_lo_inr,
                      d_hi_inr,
                      v_bits,
                      v_kfactor,
                      d_bits_for_k,
                      n_det_lvl)

    print(datetime.now() - startTime)
    sys.exit(0)
